commit ac950976f70f4bb7af201aa38c0d7cbd4f822169
Author: Colin Fleming <cj_fleming@sky.com>
Date:   Tue Jan 5 22:23:43 2016 +0000

    Add some more Bootsrap panels
    
    "firewall_aliases.php"
    - add gettext to the H2 tag
    - remove debug code
    
    "sevices_igmpproxy.php"
    "services_pppoe.php"
    "vpn_ipsec_keys.php"
    "status_gateways.php"
    "status_gateway_groups.php"
    "statis_services.php"
    "diag_arp.php"
    "diag_ndp.php"
    - add Bootstrap panels

diff --git a/src/usr/local/www/diag_arp.php b/src/usr/local/www/diag_arp.php
index d456be95bb..8ec462397a 100644
--- a/src/usr/local/www/diag_arp.php
+++ b/src/usr/local/www/diag_arp.php
@@ -333,6 +333,10 @@ $data = msort($data, "dnsresolve");
 // Load MAC-Manufacturer table
 $mac_man = load_mac_manufacturer_table();
 ?>
+<div class="panel panel-default">
+	<div class="panel-heading"><h2 class="panel-title"><?=gettext('ARP Table')?></h2></div>
+	<div class="panel-body">
+
 <div class="table-responsive">
 	<table class="sortable-theme-bootstrap table table-striped table-hover" data-sortable>
 		<thead>
@@ -368,6 +372,9 @@ $mac_man = load_mac_manufacturer_table();
 	</table>
 </div>
 
+	</div>
+</div>
+
 <script type="text/javascript">
 //<![CDATA[
 // Clear the "loading" div once the page has loaded"
diff --git a/src/usr/local/www/diag_ndp.php b/src/usr/local/www/diag_ndp.php
index b542552175..348002d31f 100644
--- a/src/usr/local/www/diag_ndp.php
+++ b/src/usr/local/www/diag_ndp.php
@@ -129,6 +129,10 @@ $pgtitle = array(gettext("Diagnostics"), gettext("NDP Table"));
 include("head.inc");
 ?>
 
+<div class="panel panel-default">
+	<div class="panel-heading"><h2 class="panel-title"><?=gettext('NDP Table')?></h2></div>
+	<div class="panel-body">
+
 <div class="table-responsive">
 	<table class="table table-striped table-condensed table-hover sortable-theme-bootstrap" data-sortable>
 		<thead>
@@ -173,4 +177,7 @@ include("head.inc");
 	</table>
 </div>
 
+	</div>
+</div>
+
 <?php include("foot.inc");
diff --git a/src/usr/local/www/firewall_aliases.php b/src/usr/local/www/firewall_aliases.php
index 2733a7a63c..9862ebb084 100644
--- a/src/usr/local/www/firewall_aliases.php
+++ b/src/usr/local/www/firewall_aliases.php
@@ -212,7 +212,7 @@ display_top_tabs($tab_array);
 ?>
 
 <div class="panel panel-default">
-	<div class="panel-heading"><h2 class="panel-title">Firewall Aliases <?=$bctab?></h2></div>
+	<div class="panel-heading"><h2 class="panel-title"><?=gettext('Firewall Aliases') . " " . $bctab?></h2></div>
 	<div class="panel-body">
 
 <div class="table-responsive">
@@ -294,8 +294,8 @@ display_top_tabs($tab_array);
 </table>
 </div>
 
-	</div><!-- panel body -->
-</div><!-- panel default -->
+	</div>
+</div>
 
 <nav class="action-buttons">
 	<a href="firewall_aliases_edit.php?tab=<?=$tab?>" role="button" class="btn btn-success btn-sm">
diff --git a/src/usr/local/www/services_igmpproxy.php b/src/usr/local/www/services_igmpproxy.php
index 7face465fc..4e531ce3a2 100644
--- a/src/usr/local/www/services_igmpproxy.php
+++ b/src/usr/local/www/services_igmpproxy.php
@@ -111,6 +111,11 @@ if (is_subsystem_dirty('igmpproxy')) {
 ?>
 
 <form action="services_igmpproxy.php" method="post">
+
+<div class="panel panel-default">
+	<div class="panel-heading"><h2 class="panel-title"><?=gettext('IGMP Proxy')?></h2></div>
+	<div class="panel-body">
+
 	<div class="table-responsive">
 		<table class="table table-striped table-hover table-condensed">
 			<thead>
@@ -161,6 +166,10 @@ endforeach;
 			</tbody>
 		</table>
 	</div>
+
+	</div>
+</div>
+	
 </form>
 
 <nav class="action-buttons">
diff --git a/src/usr/local/www/services_pppoe.php b/src/usr/local/www/services_pppoe.php
index 109520bf96..fc405157aa 100644
--- a/src/usr/local/www/services_pppoe.php
+++ b/src/usr/local/www/services_pppoe.php
@@ -126,7 +126,11 @@ if (is_subsystem_dirty('vpnpppoe')) {
 }
 ?>
 
-<div class="table-responsive">
+<div class="panel panel-default">
+	<div class="panel-heading"><h2 class="panel-title"><?=gettext('PPPoE Server')?></h2></div>
+	<div class="panel-body">
+	
+	<div class="table-responsive">
 	<table class="table table-striped table-hover table-condensed">
 		<thead>
 			<tr>
@@ -168,6 +172,9 @@ endforeach;
 	</table>
 </div>
 
+	</div>
+</div>
+
 <nav class="action-buttons">
 	<a href="services_pppoe_edit.php" class="btn btn-success">
 		<i class="fa fa-plus icon-embed-btn"></i>
diff --git a/src/usr/local/www/status_gateway_groups.php b/src/usr/local/www/status_gateway_groups.php
index b88c7cd3de..d244b88ac0 100755
--- a/src/usr/local/www/status_gateway_groups.php
+++ b/src/usr/local/www/status_gateway_groups.php
@@ -92,6 +92,9 @@ $tab_array[0] = array(gettext("Gateways"), false, "status_gateways.php");
 $tab_array[1] = array(gettext("Gateway Groups"), true, "status_gateway_groups.php");
 display_top_tabs($tab_array);
 ?>
+<div class="panel panel-default">
+	<div class="panel-heading"><h2 class="panel-title"><?=gettext('Gateway Groups')?></h2></div>
+	<div class="panel-body">
 
 <div class="table-responsive">
 	<table class="table table-hover table-condensed table-striped">
@@ -204,4 +207,7 @@ display_top_tabs($tab_array);
 	</table>
 </div>
 
+	</div>
+</div>
+
 <?php include("foot.inc");
diff --git a/src/usr/local/www/status_gateways.php b/src/usr/local/www/status_gateways.php
index 97c00514ec..f6ad4894ab 100644
--- a/src/usr/local/www/status_gateways.php
+++ b/src/usr/local/www/status_gateways.php
@@ -87,6 +87,9 @@ $tab_array[] = array(gettext("Gateways"), true, "status_gateways.php");
 $tab_array[] = array(gettext("Gateway Groups"), false, "status_gateway_groups.php");
 display_top_tabs($tab_array);
 ?>
+<div class="panel panel-default">
+	<div class="panel-heading"><h2 class="panel-title"><?=gettext('Gateways')?></h2></div>
+	<div class="panel-body">
 
 <div class="table-responsive">
 	<table class="table table-striped table-hover table-condensed sortable-theme-bootstrap" data-sortable>
@@ -188,4 +191,7 @@ display_top_tabs($tab_array);
 	</table>
 </div>
 
+	</div>
+</div>
+
 <?php include("foot.inc"); ?>
diff --git a/src/usr/local/www/status_services.php b/src/usr/local/www/status_services.php
index a944696b49..905057acd7 100755
--- a/src/usr/local/www/status_services.php
+++ b/src/usr/local/www/status_services.php
@@ -118,6 +118,10 @@ if (count($services) > 0) {
 	<input id="id" type="hidden" name="id" value=""/>
 	<input id="zone" type="hidden" name="zone" value=""/>
 
+<div class="panel panel-default">
+	<div class="panel-heading"><h2 class="panel-title"><?=gettext('Services')?></h2></div>
+	<div class="panel-body">
+
 	<div class="panel-body panel-default">
 		<div class="table-responsive">
 			<table class="table table-striped table-hover table-condensed sortable-theme-bootstrap" data-sortable>
@@ -184,6 +188,10 @@ if (count($services) > 0) {
 			</table>
 		</div>
 	</div>
+
+	</div>
+</div>
+
 </form>
 <?php
 } else {
diff --git a/src/usr/local/www/vpn_ipsec_keys.php b/src/usr/local/www/vpn_ipsec_keys.php
index 7fcd642003..c3886bb5ac 100644
--- a/src/usr/local/www/vpn_ipsec_keys.php
+++ b/src/usr/local/www/vpn_ipsec_keys.php
@@ -128,6 +128,10 @@ if (is_subsystem_dirty('ipsec')) {
 	display_top_tabs($tab_array);
 ?>
 
+<div class="panel panel-default">
+	<div class="panel-heading"><h2 class="panel-title"><?=gettext('Pre-Shared Keys')?></h2></div>
+	<div class="panel-body">
+
 <div class="table-responsive">
 	<table class="table table-striped table-hover">
 		<thead>
@@ -196,6 +200,9 @@ if (is_subsystem_dirty('ipsec')) {
 	</table>
 </div>
 
+	</div>
+</div>
+
 <nav class="action-buttons">
 	<a class="btn btn-success btn-sm" href="vpn_ipsec_keys_edit.php">
 		<i class="fa fa-plus icon-embed-btn"></i>