commit d4da62498807b8267b62e61f752ed9737c1de5ff
Author: Scott Ullrich <sullrich@pfsense.org>
Date:   Sun Oct 12 21:24:10 2008 +0000

    Do not hard code white

diff --git a/usr/local/www/firewall_schedule_edit.php b/usr/local/www/firewall_schedule_edit.php
index baf5e09eb1..3cda9a9f16 100644
--- a/usr/local/www/firewall_schedule_edit.php
+++ b/usr/local/www/firewall_schedule_edit.php
@@ -815,7 +815,7 @@ EOD;
 						?>	
 	                        <div id="<?php echo date("F y",mktime(0, 0, 0, date($monthcounter), 1, date($yearcounter)));?>" z-index:-1000; style="position:relative; display:<?php if($firstmonth)echo "block";else echo "none";?>">    	
 		                   	<TABLE BORDER=1 CELLSPACING=1 CELLPADDING=1 id="calTable" class="tabcont">
-								<TR><TD COLSPAN="7" ALIGN=center class="listbg"><B><font color="white"><?php echo date("F Y", mktime(0, 0, 0, date($monthcounter), 1, date($yearcounter)));?></B></TD>
+								<TR><TD COLSPAN="7" ALIGN=center class="listbg"><B><?php echo date("F Y", mktime(0, 0, 0, date($monthcounter), 1, date($yearcounter)));?></B></TD>
 								</TR>							
 								<TR>																
 									<TD ALIGN=center class="listhdrr" style="cursor: pointer;" onClick="daytoggle('w1p1');"><u><b>Mon</b></u></TD>
@@ -967,10 +967,10 @@ EOD;
 						<table id="scheduletable">
 							<tbody>
 								<tr>
-									<TD  ALIGN=center class="listbg" width="35%"><font color="white">Day(s)</td>
-									<TD  ALIGN=center class="listbg" width="12%"><font color="white">Start Time</td>
-									<TD  ALIGN=center class="listbg" width="11%"><font color="white">Stop Time</td>
-									<TD  ALIGN=center class="listbg" width="42%"><font color="white">Description</td>
+									<TD ALIGN="center" class="listbg" width="35%">Day(s)</td>
+									<TD ALIGN="center" class="listbg" width="12%">Start Time</td>
+									<TD ALIGN="center" class="listbg" width="11%">Stop Time</td>
+									<TD ALIGN="center" class="listbg" width="42%">Description</td>
 								</tr>
 								<?php
 								if ($getSchedule){
diff --git a/usr/local/www/interfaces_bridge.php b/usr/local/www/interfaces_bridge.php
index a66d53bf77..12514009ea 100644
--- a/usr/local/www/interfaces_bridge.php
+++ b/usr/local/www/interfaces_bridge.php
@@ -104,9 +104,7 @@ include("head.inc");
 					<?=htmlspecialchars($bridge['members']);?>
                   </td>
                   <td class="listbg">
-		    <font color="white">
                     <?=htmlspecialchars($bridge['descr']);?>&nbsp;
-		    </font>
                   </td>
                   <td valign="middle" nowrap class="list"> <a href="interfaces_bridge_edit.php?id=<?=$i;?>"><img src="./themes/<?= $g['theme']; ?>/images/icons/icon_e.gif" width="17" height="17" border="0"></a>
                      &nbsp;<a href="interfaces_bridge.php?act=del&id=<?=$i;?>" onclick="return confirm('Do you really want to delete this bridge tunnel?')"><img src="./themes/<?= $g['theme']; ?>/images/icons/icon_x.gif" width="17" height="17" border="0"></a></td>
diff --git a/usr/local/www/interfaces_gif.php b/usr/local/www/interfaces_gif.php
index aa6b99f15a..21ef0c18d9 100644
--- a/usr/local/www/interfaces_gif.php
+++ b/usr/local/www/interfaces_gif.php
@@ -112,9 +112,7 @@ include("head.inc");
 					<?=htmlspecialchars($gif['remote-addr']);?>
                   </td>
                   <td class="listbg">
-		    <font color="white">
                     <?=htmlspecialchars($gif['descr']);?>&nbsp;
-		    </font>
                   </td>
                   <td valign="middle" nowrap class="list"> <a href="interfaces_gif_edit.php?id=<?=$i;?>"><img src="./themes/<?= $g['theme']; ?>/images/icons/icon_e.gif" width="17" height="17" border="0"></a>
                      &nbsp;<a href="interfaces_gif.php?act=del&id=<?=$i;?>" onclick="return confirm('Do you really want to delete this gif tunnel?')"><img src="./themes/<?= $g['theme']; ?>/images/icons/icon_x.gif" width="17" height="17" border="0"></a></td>
diff --git a/usr/local/www/interfaces_gre.php b/usr/local/www/interfaces_gre.php
index dbea9dceb9..51698ed6cc 100644
--- a/usr/local/www/interfaces_gre.php
+++ b/usr/local/www/interfaces_gre.php
@@ -112,9 +112,7 @@ include("head.inc");
 					<?=htmlspecialchars($gre['remote-addr']);?>
                   </td>
                   <td class="listbg">
-		    <font color="white">
                     <?=htmlspecialchars($gre['descr']);?>&nbsp;
-		    </font>
                   </td>
                   <td valign="middle" nowrap class="list"> <a href="interfaces_gre_edit.php?id=<?=$i;?>"><img src="./themes/<?= $g['theme']; ?>/images/icons/icon_e.gif" width="17" height="17" border="0"></a>
                      &nbsp;<a href="interfaces_gre.php?act=del&id=<?=$i;?>" onclick="return confirm('Do you really want to delete this GRE tunnel?')"><img src="./themes/<?= $g['theme']; ?>/images/icons/icon_x.gif" width="17" height="17" border="0"></a></td>
diff --git a/usr/local/www/interfaces_lagg.php b/usr/local/www/interfaces_lagg.php
index af74a2b419..27a21d7e0d 100644
--- a/usr/local/www/interfaces_lagg.php
+++ b/usr/local/www/interfaces_lagg.php
@@ -104,9 +104,7 @@ include("head.inc");
 					<?=htmlspecialchars($lagg['members']);?>
                   </td>
                   <td class="listbg">
-		    <font color="white">
                     <?=htmlspecialchars($lagg['descr']);?>&nbsp;
-		    </font>
                   </td>
                   <td valign="middle" nowrap class="list"> <a href="interfaces_lagg_edit.php?id=<?=$i;?>"><img src="./themes/<?= $g['theme']; ?>/images/icons/icon_e.gif" width="17" height="17" border="0"></a>
                      &nbsp;<a href="interfaces_lagg.php?act=del&id=<?=$i;?>" onclick="return confirm('Do you really want to delete this lagg interface?')"><img src="./themes/<?= $g['theme']; ?>/images/icons/icon_x.gif" width="17" height="17" border="0"></a></td>
diff --git a/usr/local/www/interfaces_ppp.php b/usr/local/www/interfaces_ppp.php
index 4c0e52b720..2ad7e1d44a 100644
--- a/usr/local/www/interfaces_ppp.php
+++ b/usr/local/www/interfaces_ppp.php
@@ -126,9 +126,7 @@ include("head.inc");
 					<?=htmlspecialchars($ppp['port']);?>
                   </td>
                   <td class="listbg">
-		    <font color="white">
                     <?=htmlspecialchars($ppp['descr']);?>&nbsp;
-		    </font>
                   </td>
                   <td valign="middle" nowrap class="list"> <a href="interfaces_ppp_edit.php?id=<?=$i;?>"><img src="./themes/<?= $g['theme']; ?>/images/icons/icon_e.gif" width="17" height="17" border="0"></a>
                      &nbsp;<a href="interfaces_ppp.php?act=del&id=<?=$i;?>" onclick="return confirm('Do you really want to delete this PPP interface?')"><img src="./themes/<?= $g['theme']; ?>/images/icons/icon_x.gif" width="17" height="17" border="0"></a></td>
diff --git a/usr/local/www/interfaces_vlan.php b/usr/local/www/interfaces_vlan.php
index 84b4a7050d..b7f7a50115 100755
--- a/usr/local/www/interfaces_vlan.php
+++ b/usr/local/www/interfaces_vlan.php
@@ -113,9 +113,7 @@ include("head.inc");
 					<?=htmlspecialchars($vlan['tag']);?>
                   </td>
                   <td class="listbg">
-		    <font color="white">
                     <?=htmlspecialchars($vlan['descr']);?>&nbsp;
-		    </font>
                   </td>
                   <td valign="middle" nowrap class="list"> <a href="interfaces_vlan_edit.php?id=<?=$i;?>"><img src="./themes/<?= $g['theme']; ?>/images/icons/icon_e.gif" width="17" height="17" border="0"></a>
                      &nbsp;<a href="interfaces_vlan.php?act=del&id=<?=$i;?>" onclick="return confirm('Do you really want to delete this VLAN?')"><img src="./themes/<?= $g['theme']; ?>/images/icons/icon_x.gif" width="17" height="17" border="0"></a></td>
diff --git a/usr/local/www/services_dhcp.php b/usr/local/www/services_dhcp.php
index 12391efea6..5be708b53d 100755
--- a/usr/local/www/services_dhcp.php
+++ b/usr/local/www/services_dhcp.php
@@ -681,7 +681,7 @@ function show_netboot_config() {
                     <?=htmlspecialchars($mapent['hostname']);?>&nbsp;
                   </td>	
                   <td class="listbg" ondblclick="document.location='services_dhcp_edit.php?if=<?=$if;?>&id=<?=$i;?>';">
-                    <font color="#FFFFFF"><?=htmlspecialchars($mapent['descr']);?>&nbsp;</font>
+                    <?=htmlspecialchars($mapent['descr']);?>&nbsp;
                   </td>
                   <td valign="middle" nowrap class="list">
                     <table border="0" cellspacing="0" cellpadding="1">
diff --git a/usr/local/www/services_dnsmasq.php b/usr/local/www/services_dnsmasq.php
index 2829e00063..e416011b4e 100755
--- a/usr/local/www/services_dnsmasq.php
+++ b/usr/local/www/services_dnsmasq.php
@@ -253,7 +253,7 @@ function enable_change(enable_over) {
                  <td class="listr">
                    <?=$doment['ip'];?>&nbsp;
                  </td>
-                 <td class="listbg"><font color="#FFFFFF">
+                 <td class="listbg">
                    <?=htmlspecialchars($doment['descr']);?>&nbsp;
                  </td>
                  <td valign="middle" nowrap class="list"> <a href="services_dnsmasq_domainoverride_edit.php?id=<?=$i;?>"><img src="./themes/<?= $g['theme']; ?>/images/icons/icon_e.gif" width="17" height="17" border="0"></a>
diff --git a/usr/local/www/services_dyndns.php b/usr/local/www/services_dyndns.php
index ee79063b10..2f728717c2 100755
--- a/usr/local/www/services_dyndns.php
+++ b/usr/local/www/services_dyndns.php
@@ -103,9 +103,7 @@ include("head.inc");
 					<?=htmlspecialchars($dyndns['host']);?>
                   </td>
                   <td class="listbg">
-		    <font color="white">
                     <?=htmlspecialchars($dyndns['descr']);?>&nbsp;
-		    </font>
                   </td>
                   <td valign="middle" nowrap class="list"> <a href="services_dyndns_edit.php?id=<?=$i;?>"><img src="./themes/<?= $g['theme']; ?>/images/icons/icon_e.gif" width="17" height="17" border="0"></a>
                      &nbsp;<a href="services_dyndns.php?act=del&id=<?=$i;?>" onclick="return confirm('Do you really want to delete this VLAN?')"><img src="./themes/<?= $g['theme']; ?>/images/icons/icon_x.gif" width="17" height="17" border="0"></a></td>
diff --git a/usr/local/www/services_proxyarp.php b/usr/local/www/services_proxyarp.php
index 11b02bc7ef..e358061072 100755
--- a/usr/local/www/services_proxyarp.php
+++ b/usr/local/www/services_proxyarp.php
@@ -115,7 +115,7 @@ include("head.inc");
 							echo $arpent['range']['from'] . "-" . $arpent['range']['to'];
                     ?>&nbsp;
                   </td>
-                  <td class="listbg" ondblclick="document.location='services_proxyarp_edit.php?id=<?=$i;?>';"><font color="white">
+                  <td class="listbg" ondblclick="document.location='services_proxyarp_edit.php?id=<?=$i;?>';">
                     <?=htmlspecialchars($arpent['descr']);?>&nbsp;
                   </td>
                   <td valign="middle" nowrap class="list">
diff --git a/usr/local/www/services_rfc2136.php b/usr/local/www/services_rfc2136.php
index 124bcefd07..082a5c9e16 100644
--- a/usr/local/www/services_rfc2136.php
+++ b/usr/local/www/services_rfc2136.php
@@ -91,9 +91,7 @@ include("head.inc");
 					<?=htmlspecialchars($rfc2136['host']);?>
                   </td>
                   <td class="listbg">
-		    <font color="white">
                     <?=htmlspecialchars($rfc2136['descr']);?>&nbsp;
-		    </font>
                   </td>
                   <td valign="middle" nowrap class="list"> <a href="services_rfc2136_edit.php?id=<?=$i;?>"><img src="./themes/<?= $g['theme']; ?>/images/icons/icon_e.gif" width="17" height="17" border="0"></a>
                      &nbsp;<a href="services_rfc2136.php?act=del&id=<?=$i;?>" onclick="return confirm('Do you really want to delete this client?')"><img src="./themes/<?= $g['theme']; ?>/images/icons/icon_x.gif" width="17" height="17" border="0"></a></td>
diff --git a/usr/local/www/services_rfc2136_edit.php b/usr/local/www/services_rfc2136_edit.php
index d5d37a7f80..175e465620 100644
--- a/usr/local/www/services_rfc2136_edit.php
+++ b/usr/local/www/services_rfc2136_edit.php
@@ -83,9 +83,7 @@ include("head.inc");
 					<?=htmlspecialchars($rfc2136['host']);?>
                   </td>
                   <td class="listbg">
-		    <font color="white">
                     <?=htmlspecialchars($rfc2136['descr']);?>&nbsp;
-		    </font>
                   </td>
                   <td valign="middle" nowrap class="list"> <a href="services_rfc2136_edit.php?id=<?=$i;?>"><img src="./themes/<?= $g['theme']; ?>/images/icons/icon_e.gif" width="17" height="17" border="0"></a>
                      &nbsp;<a href="services_rfc2136.php?act=del&id=<?=$i;?>" onclick="return confirm('Do you really want to delete this client?')"><img src="./themes/<?= $g['theme']; ?>/images/icons/icon_x.gif" width="17" height="17" border="0"></a></td>
diff --git a/usr/local/www/services_wol.php b/usr/local/www/services_wol.php
index 2e97ea7da0..b7f3ab867f 100755
--- a/usr/local/www/services_wol.php
+++ b/usr/local/www/services_wol.php
@@ -171,7 +171,7 @@ You also can wake all clients at once: <a href="services_wol.php?wakeall=true"><
                     <a href="?mac=<?=$wolent['mac'];?>&if=<?=$wolent['interface'];?>"><?=strtolower($wolent['mac']);?></a>&nbsp;
                   </td>
                   <td class="listbg" ondblclick="document.location='services_wol_edit.php?id=<?=$i;?>';">
-                    <font color="#FFFFFF"><?=htmlspecialchars($wolent['descr']);?>&nbsp;
+                    <?=htmlspecialchars($wolent['descr']);?>&nbsp;
                   </td>
                   <td valign="middle" nowrap class="list">
                     <table border="0" cellspacing="0" cellpadding="1">